#include "cpp_eval_util.h"

bool file_exists(string name){
    ifstream f(name.c_str());
    return f.good();
}

tuple<string, float> process_result(vector<string> result, vector<string> test_case, string question_specific_fail_message){
    int passed = 0;
    int failed = 0;
    int failed_error = 0;
    int count = result.size();

    for(int i = 0; i < count; i++){
        if(result[i] == "pass"){
            passed++;
        }
        else if(result[i] == "fail"){
            failed++;
        }
        else{
            failed_error++;
        }
    }

    string eval_feedback = "cpp_eval_feedback.json";
    if(!file_exists(eval_feedback)){
        cout << "FEEDBACK FILE MISSING!\n";
    }
    ifstream fb(eval_feedback.c_str());
    json func_feedback;
    fb >> func_feedback;

    string feedback = "";
    float score = 1;

    if(passed == count){
        feedback = func_feedback["pass"];
        return make_tuple(feedback, score);
    }
    else if(failed_error == 0) {
        feedback += func_feedback["fail"];
        if(question_specific_fail_message != "")
        {
            feedback += "\n" + question_specific_fail_message;
        }
        score = (float)passed / (float)count;
        return make_tuple(feedback, score);
    }
    else{
        feedback += "Failed with error!";
        score = (float)passed / (float)count;
        return make_tuple(feedback, score);
    }
}

bool is_within_margin(float a, float b, float margin){
    return abs(a - b) < margin;
}

bool is_within_margin(double a, double b, double margin){
    return abs(a - b) < margin;
}